Index: trunk/LMDZ.GENERIC/libf/phystd/interpolateH2Ocont_CKD.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/interpolateH2Ocont_CKD.F90	(revision 716)
+++ trunk/LMDZ.GENERIC/libf/phystd/interpolateH2Ocont_CKD.F90	(revision 716)
@@ -0,0 +1,259 @@
+     subroutine interpolateH2Ocont_CKD(wn,temp,presS,presF,abcoef,firstcall)
+
+!==================================================================
+!     
+!     Purpose
+!     -------
+!     Calculates the H2O continuum opacity, using a lookup table from
+!     Clough (2005).
+!
+!     Authors
+!     -------
+!     R. Wordsworth (2011)
+!     
+!==================================================================
+
+      use datafile_mod, only: datadir
+      implicit none
+
+      ! input
+      double precision wn                 ! wavenumber             (cm^-1)
+      double precision temp               ! temperature            (Kelvin)
+      double precision presS              ! self-pressure          (Pascals)
+      double precision presF              ! foreign (air) pressure (Pascals)
+
+      ! output
+      double precision abcoef             ! absorption coefficient (m^-1)
+
+      integer nS,nT
+      parameter(nS=1001)
+      parameter(nT=11)
+
+      double precision kB
+      parameter(kB=1.3806488e-23)
+
+      double precision amagatS, amagatF, abcoefS, abcoefF, Nmolec
+      double precision wn_arr(nS)
+      double precision temp_arr(nT)
+      double precision abs_arrS(nS,nT)
+      double precision abs_arrF(nS,nT)
+      double precision data_tmp(nT)
+
+      integer k
+      logical firstcall
+
+      save wn_arr, temp_arr, abs_arrS, abs_arrF
+
+      character*100 dt_file
+      integer strlen,ios
+
+      amagatS=(273.15/temp)*(presS/101325.0)
+      amagatF=(273.15/temp)*(presF/101325.0)
+
+      if(firstcall)then ! called by sugas_corrk only
+         print*,'----------------------------------------------------'
+         print*,'Initialising H2O continuum from MT_CKD data...'
+
+!     1.1 Open the ASCII files
+
+         ! nu array
+         dt_file=TRIM(datadir)//'/continuum_data/H2O_CONT_NU.dat'
+         open(33,file=dt_file,form='formatted',status='old',iostat=ios)
+         if (ios.ne.0) then        ! file not found
+           write(*,*) 'Error from interpolateH2O_cont'
+           write(*,*) 'Data file ',trim(dt_file),' not found.'
+           write(*,*)'Check that your path to datagcm:',trim(datadir)
+           write(*,*)' is correct. You can change it in callphys.def with:'
+           write(*,*)' datadir = /absolute/path/to/datagcm'
+           write(*,*)' Also check that there is a continuum_data/H2O_CONT_NU.dat there.'
+           call abort
+         else
+            do k=1,nS
+               read(33,*) wn_arr(k)
+            enddo
+         endif
+         close(33)
+
+         ! self broadening
+         dt_file=TRIM(datadir)//'/continuum_data/H2O_CONT_SELF.dat'
+         open(34,file=dt_file,form='formatted',status='old',iostat=ios)
+         if (ios.ne.0) then        ! file not found
+           write(*,*) 'Error from interpolateH2O_cont'
+           write(*,*) 'Data file ',trim(dt_file),' not found.'
+           write(*,*)'Check that your path to datagcm:',trim(datadir)
+           write(*,*)' is correct. You can change it in callphys.def with:'
+           write(*,*)' datadir = /absolute/path/to/datagcm'
+           write(*,*)' Also check that there is a continuum_data/H2O_CONT_SELF.dat there.'
+           call abort
+         else
+            do k=1,nS
+               read(34,*) data_tmp
+               abs_arrS(k,1:nT)=data_tmp(1:nT)
+            end do
+         endif
+         close(34)
+
+         ! foreign (N2+O2+Ar) broadening
+         dt_file=TRIM(datadir)//'/continuum_data/H2O_CONT_FOREIGN.dat'
+         open(35,file=dt_file,form='formatted',status='old',iostat=ios)
+         if (ios.ne.0) then        ! file not found
+           write(*,*) 'Error from interpolateH2O_cont'
+           write(*,*) 'Data file ',trim(dt_file),' not found.'
+           write(*,*)'Check that your path to datagcm:',trim(datadir)
+           write(*,*)' is correct. You can change it in callphys.def with:'
+           write(*,*)' datadir = /absolute/path/to/datagcm'
+           write(*,*)' Also check that there is a continuum_data/H2O_CONT_FOREIGN.dat there.'
+           call abort
+         else
+            do k=1,nS
+               read(35,*) data_tmp
+               abs_arrF(k,1:nT)=data_tmp(1:nT)
+            end do
+         endif
+         close(35)
+
+         temp_arr(1)  = 200.
+         temp_arr(2)  = 250.
+         temp_arr(3)  = 300.
+         temp_arr(4)  = 350.
+         temp_arr(5)  = 400.
+         temp_arr(6)  = 450.
+         temp_arr(7)  = 500.
+         temp_arr(8)  = 550.
+         temp_arr(9)  = 600.
+         temp_arr(10) = 650.
+         temp_arr(11) = 700.
+
+         print*,'interpolateH2Ocont: At wavenumber ',wn,' cm^-1'
+         print*,'   temperature ',temp,' K'
+         print*,'   H2O pressure ',presS,' Pa'
+         print*,'   air pressure ',presF,' Pa'
+
+         call bilinearH2Ocont(wn_arr,temp_arr,abs_arrS,wn,temp,abcoefS)
+         print*,'the self absorption is ',abcoefS,' cm^2 molecule^-1'
+
+         call bilinearH2Ocont(wn_arr,temp_arr,abs_arrF,wn,temp,abcoefF)
+         print*,'the foreign absorption is ',abcoefF,' cm^2 molecule^-1'
+
+         print*,'We have ',amagatS,' amagats of H2O vapour'
+         print*,'and ',amagatF,' amagats of air'
+
+         abcoef = abcoefS*amagatS + abcoefF*amagatF ! Eq. (15) in Clough (1989)
+         abcoef = abcoef*(presS/(presF+presS))      ! take H2O mixing ratio into account
+                                                    ! abs coeffs are given per molecule of H2O
+
+         Nmolec = (presS+presF)/(kB*temp)           ! assume ideal gas
+         print*,'Total number of molecules per m^3 is',Nmolec
+
+         abcoef = abcoef*Nmolec/(100.0**2)          ! convert to m^-1
+         print*,'So the total absorption is ',abcoef,' m^-1'
+         print*,'And optical depth / km : ',1000.0*abcoef
+
+      else
+
+         call bilinearH2Ocont(wn_arr,temp_arr,abs_arrS,wn,temp,abcoefS)
+         call bilinearH2Ocont(wn_arr,temp_arr,abs_arrF,wn,temp,abcoefF)
+
+         abcoef = abcoefS*amagatS + abcoefF*amagatF
+         abcoef = abcoef*(presS/(presF+presS)) 
+
+         Nmolec = (presS+presF)/(kB*temp)
+         abcoef = abcoef*Nmolec/(100.0**2) 
+
+         if(wn.gt.500 .and. wn.lt.1400)then
+         elseif(wn.gt.2100 .and. wn.lt.3000)then
+         else
+            abcoef = 0.0
+         endif
+
+         ! unlike for Rayleigh scattering, we do not currently weight by the BB function
+         ! however our bands are normally thin, so this is no big deal.
+
+      endif
+
+      return
+    end subroutine interpolateH2Ocont_CKD
+
+
+!-------------------------------------------------------------------------
+      subroutine bilinearH2Ocont(x_arr,y_arr,f2d_arr,x_in,y_in,f)
+!     Necessary for interpolation of continuum data
+
+      implicit none
+
+      integer nX,nY,i,j,a,b
+      parameter(nX=1001)
+      parameter(nY=11)
+
+      real*8 x_in,y_in,x,y,x1,x2,y1,y2
+      real*8 f,f11,f12,f21,f22,fA,fB
+      real*8 x_arr(nX)
+      real*8 y_arr(nY)
+      real*8 f2d_arr(nX,nY)
+      
+      integer strlen
+      character*100 label
+      label='subroutine bilinear'
+
+      x=x_in
+      y=y_in
+
+!     1st check we're within the wavenumber range
+      if ((x.lt.x_arr(2)).or.(x.gt.x_arr(nX-2))) then
+         f=0.0D+0
+         return
+      else
+         
+!     in the x (wavenumber) direction 1st
+         i=1
+ 10      if (i.lt.(nX+1)) then
+            if (x_arr(i).gt.x) then
+               x1=x_arr(i-1)
+               x2=x_arr(i)
+               a=i-1
+               i=9999
+            endif
+            i=i+1
+            goto 10
+         endif
+      endif
+      
+      if ((y.lt.y_arr(1)).or.(y.gt.y_arr(nY))) then
+         write(*,*) 'Warning from bilinearH2Ocont:'
+         write(*,*) 'Outside continuum temperature range!'
+         if(y.lt.y_arr(1))then
+            y=y_arr(1)+0.01
+         endif
+         if(y.gt.y_arr(nY))then
+            y=y_arr(nY)-0.01
+         endif
+      else
+
+!     in the y (temperature) direction 2nd
+         j=1
+ 20      if (j.lt.(nY+1)) then
+            if (y_arr(j).gt.y) then
+               y1=y_arr(j-1)
+               y2=y_arr(j)
+               b=j-1
+               j=9999
+            endif
+            j=j+1
+            goto 20
+         endif
+      endif
+      
+      f11=f2d_arr(a,b)
+      f21=f2d_arr(a+1,b)
+      f12=f2d_arr(a,b+1)
+      f22=f2d_arr(a+1,b+1)
+      
+!     1st in x-direction
+      fA=f11*(x2-x)/(x2-x1)+f21*(x-x1)/(x2-x1)
+      fB=f12*(x2-x)/(x2-x1)+f22*(x-x1)/(x2-x1)
+      
+!     then in y-direction
+      f=fA*(y2-y)/(y2-y1)+fB*(y-y1)/(y2-y1)
+
+      return
+    end subroutine bilinearH2Ocont
Index: trunk/LMDZ.GENERIC/libf/phystd/interpolateH2Ocont_PPC.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/interpolateH2Ocont_PPC.F90	(revision 716)
+++ trunk/LMDZ.GENERIC/libf/phystd/interpolateH2Ocont_PPC.F90	(revision 716)
@@ -0,0 +1,84 @@
+     subroutine interpolateH2Ocont_PPC(wn,temp,presS,presF,abcoef,firstcall)
+
+!==================================================================
+!     
+!     Purpose
+!     -------
+!     Calculates the H2O continuum opacity, using the formulae
+!     provided in Pierrehumbert, PPC (2010). As this is based on
+!     the CKD continuum, it provides a useful check for the 
+!     implementation of the more general interpolateH2Ocont_CKD.F90.
+!
+!     Authors
+!     -------
+!     R. Wordsworth (2012)
+!     
+!==================================================================
+
+      use watercommon_h, only: mH2O
+      use datafile_mod, only: datadir
+      implicit none
+
+      ! input
+      double precision wn                 ! wavenumber             (cm^-1)
+      double precision temp               ! temperature            (Kelvin)
+      double precision presS              ! self-pressure          (Pascals)
+      double precision presF              ! foreign (air) pressure (Pascals)
+
+      ! parameters
+      double precision, parameter :: T0 = 296.0
+      double precision, parameter :: p0 = 1.D+4
+
+      ! variables
+      double precision rho_w, x
+
+      ! output
+      double precision abcoef             ! absorption coefficient (m^-1)
+
+      logical firstcall
+
+      x = wn - 2500.
+
+      if(firstcall)then ! called by sugas_corrk only
+         print*,'----------------------------------------------------'
+         print*,'Testing H2O continuum...'
+
+         print*,'interpolateH2Ocont: At wavenumber ',wn,' cm^-1'
+         print*,'   temperature ',temp,' K'
+         print*,'   H2O pressure ',presS,' Pa'
+
+         rho_w = presS/((8.31446/(mH2O/1000.))*temp)
+
+         if(wn.gt.500 .and. wn.lt.1400)then
+            abcoef = exp(12.167 - 0.050898*wn + 8.3207e-5*wn**2 - 7.0748e-8*wn**3 + 2.3261e-11*wn**4)*(T0/temp)**4.25*(presS/p0)
+         elseif(wn.gt.2100 .and. wn.lt.3000)then
+            abcoef = exp(-6.0055 - 0.0021363*x + 6.4723e-7*x**2 - 1.493e-8*x**3 + 2.5621e-11*x**4 + 7.328e-14*x**5)*(T0/temp)**4.25*(presS/p0)
+         else
+            abcoef = 0.0
+         endif
+         abcoef = abcoef*rho_w
+
+         print*,'The self absorption is ',abcoef,' m^-1'
+         print*,'And optical depth / km : ',1000.0*abcoef
+
+      else
+
+         rho_w = presS/((8.31446/(mH2O/1000.))*temp)
+
+         if(wn.gt.500 .and. wn.lt.1400)then
+            abcoef = exp(12.167 - 0.050898*wn + 8.3207e-5*wn**2 - 7.0748e-8*wn**3 + 2.3261e-11*wn**4)*(T0/temp)**4.25*(presS/p0)
+         elseif(wn.gt.2100 .and. wn.lt.3000)then
+            abcoef = exp(-6.0055 - 0.0021363*x + 6.4723e-7*x**2 - 1.493e-8*x**3 + 2.5621e-11*x**4 + 7.328e-14*x**5)*(T0/temp)**4.25*(presS/p0)
+         else
+            abcoef = 0.0
+         endif
+         abcoef = abcoef*rho_w
+
+         ! unlike for Rayleigh scattering, we do not currently weight by the BB function
+         ! however our bands are normally thin, so this is no big deal.
+
+      endif
+
+      return
+    end subroutine interpolateH2Ocont_PPC
+
Index: trunk/LMDZ.GENERIC/libf/phystd/interpolateN2H2.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/interpolateN2H2.F90	(revision 716)
+++ trunk/LMDZ.GENERIC/libf/phystd/interpolateN2H2.F90	(revision 716)
@@ -0,0 +1,209 @@
+subroutine interpolateN2H2(wn,temp,presN2,presH2,abcoef,firstcall)
+
+  !==================================================================
+  !     
+  !     Purpose
+  !     -------
+  !     Calculates the N2-H2 CIA opacity, using a lookup table from
+  !     HITRAN (2011)
+  !
+  !     Authors
+  !     -------
+  !     R. Wordsworth (2011)
+  !     
+  !==================================================================
+
+  use datafile_mod, only: datadir
+  implicit none
+
+  ! input
+  double precision wn                 ! wavenumber             (cm^-1)
+  double precision temp               ! temperature            (Kelvin)
+  double precision presN2             ! N2 partial pressure    (Pascals)
+  double precision presH2             ! H2 partial pressure    (Pascals)
+
+  ! output
+  double precision abcoef             ! absorption coefficient (m^-1)
+
+  integer nS,nT
+  parameter(nS=1914)
+  parameter(nT=10)
+
+  double precision, parameter :: losch = 2.6867774e19
+  ! Loschmit's number (molecule cm^-3 at STP) 
+  ! converts cm^5 molecule^-2 --> cm^-1 amagat^-2
+  ! see Richard et al. 2011, JQSRT for details
+
+  double precision amagatN2
+  double precision amagatH2
+  double precision wn_arr(nS)
+  double precision temp_arr(nT)
+  double precision abs_arr(nS,nT)
+
+  integer k,iT
+  logical firstcall
+
+  save wn_arr, temp_arr, abs_arr
+
+  character*100 dt_file
+  integer strlen,ios
+
+  character(LEN=*), parameter :: fmat1 = "(A20,F10.3,F10.3,I7,F7.1,E10.3,F5.3)"
+
+  character*20 bleh
+  double precision blah, Ttemp
+  integer nres
+
+  if(temp.gt.400)then
+     print*,'Your temperatures are too high for this N2-H2 CIA dataset.'
+     print*,'Please run mixed N2-H2 atmospheres below T = 400 K.'      
+     stop
+  endif
+
+  amagatN2 = (273.15/temp)*(presN2/101325.0)
+  amagatH2 = (273.15/temp)*(presH2/101325.0)
+
+  if(firstcall)then ! called by sugas_corrk only
+     print*,'----------------------------------------------------'
+     print*,'Initialising N2-H2 continuum from HITRAN database...'
+
+     !     1.1 Open the ASCII files
+     dt_file=TRIM(datadir)//'/continuum_data/N2-H2_2011.cia'
+
+     open(33,file=dt_file,form='formatted',status='old',iostat=ios)
+     if (ios.ne.0) then        ! file not found
+        write(*,*) 'Error from interpolateN2H2'
+        write(*,*) 'Data file ',trim(dt_file),' not found.'
+        write(*,*) 'Check that your path to datagcm:',trim(datadir)
+        write(*,*) 'is correct. You can change it in callphys.def with:'
+        write(*,*) 'datadir = /absolute/path/to/datagcm'
+        write(*,*) 'Also check that the continuum data continuum_data/N2-H2_2011.cia is there.'
+        call abort
+     else
+
+        do iT=1,nT
+
+           read(33,fmat1) bleh,blah,blah,nres,Ttemp
+           if(nS.ne.nres)then
+              print*,'Resolution given in file: ',trim(dt_file)
+              print*,'is ',nres,', which does not match nS.'
+              print*,'Please adjust nS value in interpolateN2H2.F90'
+              stop
+           endif
+           temp_arr(iT)=Ttemp
+
+           do k=1,nS
+              read(33,*) wn_arr(k),abs_arr(k,it)
+           end do
+
+        end do
+
+     endif
+     close(33)
+
+     print*,'interpolateN2H2: At wavenumber ',wn,' cm^-1'
+     print*,'   temperature                 ',temp,' K'
+     print*,'   N2 partial pressure         ',presN2,' Pa'
+     print*,'   and H2 partial pressure     ',presH2,' Pa'
+
+     call bilinearN2H2(wn_arr,temp_arr,abs_arr,wn,temp,abcoef)
+
+     print*,'the absorption is ',abcoef,' cm^5 molecule^-2'
+     print*,'or ',abcoef*losch**2,' cm^-1 amagat^-2'
+
+     abcoef=abcoef*losch**2*100.0*amagatN2*amagatH2 ! convert to m^-1
+
+     print*,'We have ',amagatN2,' amagats of N2'
+     print*,'and     ',amagatH2,' amagats of H2'
+     print*,'So the absorption is ',abcoef,' m^-1'
+
+  else
+
+     call bilinearN2H2(wn_arr,temp_arr,abs_arr,wn,temp,abcoef)
+     abcoef=abcoef*losch**2*100.0*amagatN2*amagatH2 ! convert to m^-1
+
+     ! unlike for Rayleigh scattering, we do not currently weight by the BB function
+     ! however our bands are normally thin, so this is no big deal.
+
+  endif
+
+  return
+end subroutine interpolateN2H2
+
+
+!-------------------------------------------------------------------------
+subroutine bilinearN2H2(x_arr,y_arr,f2d_arr,x_in,y_in,f)
+
+  implicit none
+
+  integer nX,nY,i,j,a,b
+  parameter(nX=1914)
+  parameter(nY=10)
+
+  real*8 x_in,y_in,x,y,x1,x2,y1,y2
+  real*8 f,f11,f12,f21,f22,fA,fB
+  real*8 x_arr(nX)
+  real*8 y_arr(nY)
+  real*8 f2d_arr(nX,nY)
+
+  integer strlen
+  character*100 label
+  label='subroutine bilinear'
+
+  x=x_in
+  y=y_in
+
+  ! 1st check we're within the wavenumber range
+  if ((x.lt.x_arr(2)).or.(x.gt.x_arr(nX-2))) then
+     f=0.0D+0
+     return
+  else
+
+     ! in the x (wavenumber) direction 1st
+     i=1
+10   if (i.lt.(nX+1)) then
+        if (x_arr(i).gt.x) then
+           x1=x_arr(i-1)
+           x2=x_arr(i)
+           a=i-1
+           i=9999
+        endif
+        i=i+1
+        goto 10
+     endif
+  endif
+
+  if ((y.lt.y_arr(1)).or.(y.gt.y_arr(nY))) then
+     write(*,*) 'Warning from bilinearN2H2:'
+     write(*,*) 'Outside continuum temperature range!'
+     if(y.lt.y_arr(1))then
+        y=y_arr(1)+0.01
+     endif
+     if(y.gt.y_arr(nY))then
+        y=y_arr(nY)-0.01
+     endif
+  else
+
+     ! in the y (temperature) direction 2nd
+     j=1
+20   if (j.lt.(nY+1)) then
+        if (y_arr(j).gt.y) then
+           y1=y_arr(j-1)
+           y2=y_arr(j)
+           b=j-1
+           j=9999
+        endif
+        j=j+1
+        goto 20
+     endif
+  endif
+
+  f11=f2d_arr(a,b)
+  f21=f2d_arr(a+1,b)
+  f12=f2d_arr(a,b+1)
+  f22=f2d_arr(a+1,b+1)
+
+  call bilinear(f,f11,f21,f12,f22,x,x1,x2,y,y1,y2)
+
+  return
+end subroutine bilinearN2H2
Index: trunk/LMDZ.GENERIC/libf/phystd/interpolateN2N2.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/interpolateN2N2.F90	(revision 716)
+++ trunk/LMDZ.GENERIC/libf/phystd/interpolateN2N2.F90	(revision 716)
@@ -0,0 +1,205 @@
+subroutine interpolateN2N2(wn,temp,pres,abcoef,firstcall)
+
+  !==================================================================
+  !     
+  !     Purpose
+  !     -------
+  !     Calculates the N2-N2 CIA opacity, using a lookup table from
+  !     HITRAN (2011)
+  !
+  !     Authors
+  !     -------
+  !     R. Wordsworth (2011)
+  !     
+  !==================================================================
+
+  use datafile_mod, only: datadir
+  implicit none
+
+  ! input
+  double precision wn                 ! wavenumber             (cm^-1)
+  double precision temp               ! temperature            (Kelvin)
+  double precision pres               ! pressure               (Pascals)
+
+  ! output
+  double precision abcoef             ! absorption coefficient (m^-1)
+
+  integer nS,nT
+  parameter(nS=582)
+  parameter(nT=10)
+
+  double precision, parameter :: losch = 2.6867774e19
+  ! Loschmit's number (molecule cm^-3 at STP) 
+  ! converts cm^5 molecule^-2 --> cm^-1 amagat^-2
+  ! see Richard et al. 2011, JQSRT for details
+
+  double precision amagat
+  double precision wn_arr(nS)
+  double precision temp_arr(nT)
+  double precision abs_arr(nS,nT)
+
+  integer k,iT
+  logical firstcall
+
+  save wn_arr, temp_arr, abs_arr
+
+  character*100 dt_file
+  integer strlen,ios
+
+  character(LEN=*), parameter :: fmat1 = "(A20,F10.3,F10.3,I7,F7.1,E10.3,F5.3)"
+
+  character*20 bleh
+  double precision blah, Ttemp
+  integer nres
+
+
+  if(temp.gt.400)then
+     print*,'Your temperatures are too high for this N2-N2 CIA dataset.'
+     print*,'Currently, HITRAN provides data for this pair in the range 40-400 K.'
+     stop
+  endif
+
+  amagat = (273.15/temp)*(pres/101325.0)
+
+  if(firstcall)then ! called by sugas_corrk only
+     print*,'----------------------------------------------------'
+     print*,'Initialising N2-N2 continuum from HITRAN database...'
+
+     !     1.1 Open the ASCII files
+     dt_file=TRIM(datadir)//'/continuum_data/N2-N2_2011.cia'
+
+     open(33,file=dt_file,form='formatted',status='old',iostat=ios)
+     if (ios.ne.0) then        ! file not found
+        write(*,*) 'Error from interpolateN2N2'
+        write(*,*) 'Data file ',trim(dt_file),' not found.'
+        write(*,*) 'Check that your path to datagcm:',trim(datadir)
+        write(*,*) 'is correct. You can change it in callphys.def with:'
+        write(*,*) 'datadir = /absolute/path/to/datagcm'
+        write(*,*) 'Also check that the continuum data continuum_data/N2-N2_norm_2011.cia is there.'
+        call abort
+     else
+
+        do iT=1,nT
+
+           read(33,fmat1) bleh,blah,blah,nres,Ttemp
+           if(nS.ne.nres)then
+              print*,'Resolution given in file: ',trim(dt_file)
+              print*,'is ',nres,', which does not match nS.'
+              print*,'Please adjust nS value in interpolateN2N2.F90'
+              stop
+           endif
+           temp_arr(iT)=Ttemp
+
+           do k=1,nS
+              read(33,*) wn_arr(k),abs_arr(k,it)
+           end do
+
+        end do
+
+     endif
+     close(33)
+
+     print*,'interpolateN2N2: At wavenumber ',wn,' cm^-1'
+     print*,'   temperature ',temp,' K'
+     print*,'   pressure ',pres,' Pa'
+
+     call bilinearN2N2(wn_arr,temp_arr,abs_arr,wn,temp,abcoef)
+
+     print*,'the absorption is ',abcoef,' cm^5 molecule^-2'
+     print*,'or ',abcoef*losch**2,' cm^-1 amagat^-2'
+
+     abcoef=abcoef*losch**2*100.0*amagat**2 ! convert to m^-1
+
+     print*,'We have ',amagat,' amagats of N2'
+     print*,'So the absorption is ',abcoef,' m^-1'
+
+  else
+
+     call bilinearN2N2(wn_arr,temp_arr,abs_arr,wn,temp,abcoef)
+     abcoef=abcoef*losch**2*100.0*amagat**2 ! convert to m^-1
+
+     ! unlike for Rayleigh scattering, we do not currently weight by the BB function
+     ! however our bands are normally thin, so this is no big deal.
+
+  endif
+
+  return
+end subroutine interpolateN2N2
+
+
+!-------------------------------------------------------------------------
+      subroutine bilinearN2N2(x_arr,y_arr,f2d_arr,x_in,y_in,f)
+
+      implicit none
+
+      integer nX,nY,i,j,a,b
+      parameter(nX=582)
+      parameter(nY=10)
+
+      real*8 x_in,y_in,x,y,x1,x2,y1,y2
+      real*8 f,f11,f12,f21,f22,fA,fB
+      real*8 x_arr(nX)
+      real*8 y_arr(nY)
+      real*8 f2d_arr(nX,nY)
+      
+      integer strlen
+      character*100 label
+      label='subroutine bilinear'
+
+      x=x_in
+      y=y_in
+
+!     1st check we're within the wavenumber range
+      if ((x.lt.x_arr(2)).or.(x.gt.x_arr(nX-2))) then
+         f=0.0D+0
+         return
+      else
+         
+!     in the x (wavenumber) direction 1st
+         i=1
+ 10      if (i.lt.(nX+1)) then
+            if (x_arr(i).gt.x) then
+               x1=x_arr(i-1)
+               x2=x_arr(i)
+               a=i-1
+               i=9999
+            endif
+            i=i+1
+            goto 10
+         endif
+      endif
+      
+      if ((y.lt.y_arr(1)).or.(y.gt.y_arr(nY))) then
+         write(*,*) 'Warning from bilinearN2N2:'
+         write(*,*) 'Outside continuum temperature range!'
+         if(y.lt.y_arr(1))then
+            y=y_arr(1)+0.01
+         endif
+         if(y.gt.y_arr(nY))then
+            y=y_arr(nY)-0.01
+         endif
+      else
+
+!     in the y (temperature) direction 2nd
+         j=1
+ 20      if (j.lt.(nY+1)) then
+            if (y_arr(j).gt.y) then
+               y1=y_arr(j-1)
+               y2=y_arr(j)
+               b=j-1
+               j=9999
+            endif
+            j=j+1
+            goto 20
+         endif
+      endif
+      
+      f11=f2d_arr(a,b)
+      f21=f2d_arr(a+1,b)
+      f12=f2d_arr(a,b+1)
+      f22=f2d_arr(a+1,b+1)
+
+      call bilinear(f,f11,f21,f12,f22,x,x1,x2,y,y1,y2)
+
+      return
+    end subroutine bilinearN2N2
